overlay procedure filesys;
  const
    mostfiles = 100;
    soh = 1;
    eot = 4;
    ack = 6;
    nak = $15;
    can = $18;
    C = $43;
  type
    desc = string[40];
    filerec = record
    title:name;
    descrip:desc;
    submit:integer;
    date:name;
    size:integer;
    accesses:integer;
    ASCII:boolean;
    section:byte;
    public:boolean;
    end;
    channel = array[0..127] of byte;
  var
    filefile:file of filerec;
    filetab:array[0..mostfiles] of filerec;
    buffer:channel;
    datafile:file;
    chksum:byte;
    CRC:integer;
    crcmode:boolean;
    auto_install:boolean;
    enddir:integer;
    comch:char;
    teller,rest:integer;

  procedure xmit(x:byte);
    begin
      xmitchar(chr(x));
    end;

  function inbyte:byte;
    var temp:char;
    begin
      readkey(temp);
      inbyte:=ord(temp)
    end;

  procedure clearline;
    var junk:byte;
    begin
      while timedin do junk:=inbyte
    end;

  procedure vpoke(i:byte);
  var base:integer;
  begin
    base:=$1C00+i*128
   ;inline($01/>$80/$2a/base/$54/$5d/$21/buffer/$F7/$80/>$5c)
  end;

  procedure vpeek(i:byte);
  var base:integer;
  begin
    base:=$1C00+i*128
   ;inline($01/>$80/$21/buffer/$54/$5d/$2a/base/$F7/$80/>$59)
  end;

 procedure auto_install_file(filename:name); forward;

  procedure calcCRC(data:byte);
    var
      carry: boolean;
      i: byte;
    begin
      chksum:=lo(chksum+data);
      for i:=0 to 7 do begin
      carry:=(crc and $8000)<>0;
      crc:=crc shl 1;
      if (data and $80)<>0 then crc:=crc or $0001;
      if carry then crc:=crc xor $1021;
      data:=lo(data shl 1);
      end;
    end;

  procedure ctregel;
  begin
      lineout('Afbreken...  druk CTRL-X tot U de menuregel ziet.');
  end;

overlay procedure download(var successful:boolean);
    var
      inch,loop:byte;
      blocknum,period,tries,mm,ss:integer;
      done:boolean;
      size:integer;
      inch1,inch2:name;

  procedure sendcalc(ch:byte);
    begin
      xmit(ch);
      calcCRC(ch);
    end;

  procedure acknak(var inch:byte; time:integer);
    var loop,loopend:integer;
    begin
      loopend:=100*time;
      loop:=0;
      inch:=0;
      repeat
      delay(10);
      if inready then inch:=inbyte;
      loop :=loop+1;
      until (inch in [ack,nak,can,C]) or (loop>=loopend) or not cts;
    end;

  function min(a,b:integer):integer;
  begin if a<b then min:=a else min:=b end;


  procedure bufinit;
  var i:byte;
  begin
    rest:=filesize(datafile);
    for i:=1 to min(rest,32) do
    begin
    blockread(datafile,buffer,1);
    vpoke(i)
    end;
    vpeek(1);
    teller:=1; rest:=rest-1
  end;

  procedure getblok;
  var i:byte;
  begin
    if teller=32 then begin
    teller:=0;
    for i:=1 to min(rest,32) do
    begin
    blockread(datafile,buffer,1)
    ;vpoke(i)
    end
    end;
    teller:=teller+1;
    vpeek(teller);
    rest:=rest-1
  end;

  procedure send_time;
  {Berekent de transfertijd bij CRC en 1200 BPS}
  var tr_time:real;
      size   :integer;
  begin
    size:=filesize(datafile);
    tr_time:=size * 23.5 / 1200;
    mm:=trunc(tr_time);
    ss:=round(60.0 * frac(tr_time))
  end;

begin
{$I-}
      reset(datafile);
{$I+}
      if IOresult<>0 then lineout('File is niet aanwezig.')
      else begin
      str(filesize(datafile):4, templ);
      send_time;
      str(mm:2,inch1);str(ss:2,inch2);
      charout(cr);charout(lf);
      lineout('Klaar voor download : XMODEM-protocol');
      lineout('Aantal blokken is   :'+templ);
      lineout('File is geopend...');
      lineout('Transfertijd bij CRC en 1200 bps ongeveer: '+inch1+':'+inch2+'.');
      charout(cr);charout(lf);
      ctregel;
      bufinit;
      done:=false;
      tries:=0;
      blocknum:=1;
      crcmode:=false;
      repeat
      acknak(inch,60);
      if inch=0 then inch:=can;
      if inch=C then begin
      crcmode:=true;
      writeln('CRC mode.');
      end;
      if inch=ack then begin
      if rest=0 then done:=true else begin
      write(cr+'Blok #',blocknum:4);
      getblok;
      blocknum:=blocknum+1;
      tries:=0;
      end;
      end
      else tries:=tries+1;
      if (inch <> can) and cts and not done then begin
      xmit(soh);
      xmit(lo(blocknum));
      xmit(255-lo(blocknum));
      chksum:=0;
      crc:=0;
      for loop:=0 to 127 do sendcalc(buffer[loop]);
      calcCRC(0);
      calcCRC(0);
      if crcmode then begin xmit(hi(crc)); xmit(lo(crc)); end
      else xmit(chksum);
      end;
      if tries=5 then crcmode:=not crcmode;
      until (inch=can) or done or (tries=10) or not cts;
      successful:=done;
      tries:=0;
      if successful and cts then repeat
      xmit(eot);
      acknak(inch,10);
      tries:=tries+1;
      until (inch=ack) or (tries>10) or not cts;
      if cts and (inch<>can) and not successful then xmit(can);
      close(datafile)
      end
    end;

overlay procedure upload(var successful:boolean);
   var
     blocknum,tries,byteloc:integer;
     comp, locblock,crc2:integer;
     fatal,error,done:boolean;
     opening,inch,locrc:byte;
     hicrc,csum2,mode:byte;

  function acknakout(ch:byte):boolean;
    var times,loops:integer;
    begin
      times:=0;
      repeat
      loops:=0;
      xmit(ch);
      while (loops<10) and not timedin do loops:=loops+1;
      times:=times+1;
      until inready or (times>9) or not cts;
      acknakout:=inready and cts;
    end;

  function recchar(var error:boolean):byte;
    var temp,temp1:byte;
    begin
      temp:=0; temp1:=1;
      if not cts then error:=true;
      if not error then begin
      while not (timedin or (temp1>2)) do temp1:=temp1+1;
      if not timedin then error:=true
      else begin
      temp:=inbyte;
      calcCRC(temp);
      recchar:=temp
      end
      end
    end;


{$I-}
    begin
      charout(lf); charout(cr);
      lineout('Klaar voor upload : XMODEM-protocol.');
      charout(lf);
      ctregel;
      tries:=0;
      done:=false;
      opening:=0;
      locblock:=1;
      rewrite(datafile);
      fatal:=ioresult>0;
      if crcmode then mode:=C else mode:=nak;
      if cts and not fatal then fatal:=not acknakout(mode);
      while cts and not (done or fatal) do begin
      tries:=tries+1;
      error:=false;
      opening:=recchar(error);
      if opening=can then fatal:=true;
      if opening=eot then done:=true;
      if (opening<>eot) and (opening<>soh) and not fatal
      then error:=true;
      if cts and not (error or fatal or done) then begin
      blocknum:=recchar(error);
      comp:=recchar(error);
      if lo(comp+blocknum+opening)<>0 then error:=true;
      byteloc:=0;
      crc:=0;
      chksum:=0;
      while (byteloc<128) and not (error or fatal) do begin
      buffer[byteloc]:=recchar(error);
      byteloc:=byteloc+1;
      end;
      if cts and not (error or fatal) then begin
      calcCRC(0);
      calcCRC(0);
      crc2:=crc;
      csum2:=chksum;
      hicrc:=recchar(error);
      if crcmode then begin
      locrc:=recchar(error);
      if (lo(crc2)<>locrc) or (hi(crc2)<>hicrc) then error:=true;
      end else if csum2<>hicrc then error:=true;
      if (lo(locblock)<>blocknum)
      and (lo(locblock)<>lo(blocknum+1))
      and not error
      then fatal:=true;
      if (lo(locblock)=blocknum) and not (error or fatal) then begin
      blockwrite(datafile, buffer,1);
      write(cr+'Blok #',blocknum:4);
      if IOresult<>0 then fatal:=true;
      tries:=0;
      locblock:=locblock+1
      end
      end
      end;
      if not (fatal or error) then flush else clearline;
      if done or not (error or fatal) then fatal:=not acknakout(ack);
      if error and not fatal then begin
      fatal:=not acknakout(nak);
      if tries>6 then crcmode:=not crcmode;
      end;
      end;
      if fatal then xmit(can);
      if done then xmit(ack);
      close(datafile);
      successful:=(IOresult=0) and done and not fatal;
      if not successful then erase(datafile);
    end;
{$I+}

overlay procedure textcap(var successful: boolean);
    var
      buffernum,where,loop,temp : byte;
      cc,cz,paused : boolean;
      withecho,done,aborted : boolean;

  procedure storebuff(var buffernum: byte; var paused, aborted: boolean);
    var loop: byte;
    begin
      loop:=1;
      while (loop<buffernum) and not aborted do begin
      vpeek(loop);
      blockwrite(datafile,buffer,1);
      if IOresult>0 then aborted:=true;
      loop := loop+1
      end;
      if buffernum in [1..32] then vpeek(buffernum);
      buffernum:=0;
      repeat xmit(17) until timedin;
      paused:=false;
    end;

{$I-}
    begin
      withecho:=(getcap('Wilt U de tekst ge-echood (J/N) : ') in ['Y','J']);
      charout(lf); charout(cr);
      lineout('Klaar voor upload : ASCII-transmit');
      charout(lf);
      lineout('Afbreken... 2 x CTRL-C');
      lineout('Eind....... 2 x CTRL-Z');
      charout(lf);
      cc:=false;
      cz:=false;
      done:=false;
      paused:=false;
      buffernum:=1;
      where:=0;
      rewrite(datafile);
      aborted:=(IOresult>0);
      while cts and not (done or aborted) do begin
      if paused then
      if not timedin then storebuff(buffernum, paused, aborted);
      temp:=inbyte;
      if not cts then aborted:=true;
      if withecho then xmit(temp);
      if temp=3 then begin if cc then aborted:= true else cc:=true; end
      else cc:=false;
      if temp=26 then begin if cz then done:=true else cz:=true; end
      else cz:=false;
      buffer[where]:=temp;
      where:=where+1;
      if where>127 then begin
      where:=0;
      vpoke(buffernum);
      buffernum:=buffernum+1;
      end;
      if buffernum>28 then begin
      xmit(19);
      paused:=true;
      end;
      if buffernum>32 then aborted:=true;
      end;
      if done and cts and not aborted then begin
      buffernum := buffernum+1;
      storebuff(buffernum,paused,aborted);
      end;
      close(datafile);
      if aborted and (IOresult=0) then erase(datafile);
    successful:=done and (IOresult=0) and not aborted;
    end;
{$I+}

overlay procedure dir_drive;
  type str11   = string[11];

  var drive    : char;
      FCB      : array[0..35] of byte;
      DMA      : array[0..127] of byte;
      drive_nr : integer;

procedure dir_mask;
   var mask    :str11;

 procedure fill_FCB(dr_nr : byte; msk : str11);
    var counter : integer;
      begin
           FCB[0]:=dr_nr;
             for counter := 1 to 11 do
             FCB[counter] := ord(msk[counter]);
           FCB[12] := 0;
      end;

  begin
       drive    := fd;
       mask     := '???????????';
       drive_nr := ord(drive) - 64;
       fill_FCB(drive_nr,mask);
  end;

  procedure read_dir;
    var stop,
        index,
        offset,
        counte,
        counter   : byte;
        filename,filenames,dirfile  : name;
    begin
         index := 0;
         bdos(26,addr(DMA[0]));                        {set DMA}
         ClrScr; gotoXY(1,3);
           if not auto_install then 
           writeln('Directory voor drive: ',drive);
         stop := bdos(17,addr(FCB[0]));                {zoek eerste}
         if stop =$FF then writeln('Disk is leeg...');
           while stop <>$FF do
             begin
                  dirfile := '        .   ';
                  offset  := stop * 32;
                  for counter := 1 to 8 do
                   dirfile[counter] := chr(DMA[offset + counter]);
                  for counter := 9 to 11 do
                   dirfile[counter + 1] := chr(DMA[offset + counter]);
                  index := index + 1;
                  if auto_install then 
      begin
          counte :=1; counter:=1;
          repeat
            if dirfile[counter]<>' ' then
            begin
            filenames[counte]:=dirfile[counter];
            counte:=counte + 1; counter:=counter + 1;
            end else 
            counter:=counter + 1;
          until ((dirfile[counter]='.') and (dirfile[counter + 1]=' ')) or (counter=13);
          filename:='';
          filename:=copy(filenames,1,counte - 1);
          write(filename);
      end;
      if auto_install then auto_install_file(filename) else
         begin
            write(dirfile);
            if index mod 5 = 0 then writeln
               else write('  : ');
               end;
               stop := bdos(18);                    {zoek volgende}
             end;
          writeln;
    end;

begin
     dir_mask;
     read_dir;
end;

overlay procedure typedir(var result:integer);
  var
    temp: name;
    dirlength, offset, firstsec, loop, chrpos: integer;
  begin
    firstsec := 0; libsects := 0;
    blockread(libfile, libbuff, 1);
    if libbuff[0] <> 0 then result := 1;
    loop := 1;
    while (result = 0) and (loop <= 11) do begin
    if libbuff[loop] <> 32 then result := 1;
    loop := loop + 1;
    end;
    result := result + libbuff[12] + libbuff[13];
    if result = 0 then begin
    dirlength := libbuff[14] + 256*libbuff[15];
    if dirlength = 0 then result := 1;
    end;
    if result = 0 then begin
    loop := 0;
      while (loop < 4*dirlength-1) and (result = 0) and (firstsec = 0) do begin
      loop := loop + 1;
      offset := 32*(loop mod 4);
      if offset = 0 then blockread(libfile, libbuff, 1);
      if libbuff[offset] <> 0 then result := 1
      else begin
      temp := '';
      for chrpos := 1 to 8 do
      if libbuff[offset+chrpos] <> 32 then
      temp := temp+chr(libbuff[offset + chrpos]);
      if libbuff[offset+9] <> 32 then begin
      temp:=temp + '.';
      for chrpos:=9 to 11 do
      if libbuff[offset+chrpos] <> 32 then
      temp:=temp+chr(libbuff[offset + chrpos]);
      end;
      if cts then lineout(temp);
      end;
      end;
      result:=0;
    end;
  end;

overlay procedure arcdir(var result);
var long,long2,tot1,tot2:real
    ;i,j,numb:byte
    ;n:string[14]
    ;c:char
    ;b:byte
    ;hdr:array[0..27] of char
 
;function next:char
;begin
   if i=127 then
   begin
     i:=-1
    ;if not eof(libfile) then blockread(libfile,libbuff,1)
     else begin lineout('Onverwacht file eind.')
               ;b:=0
          end
   end
  ;i:=i+1
  ;next:=char(libbuff[i])
 end
 
;procedure skip(aantal:real)
;var klad:char; rest:integer
;begin
  ;while (aantal-3)>128 do begin blockread(libfile,libbuff,1); aantal:=aantal-128 end
  ;while (aantal-1>0) or (b=0) do
   begin
     klad:=next; aantal:=aantal-1
   end
 end
 
;function int(x:byte):integer
;var b:byte
;begin
   b:=ord(hdr[x])
  ;int:=b+256*ord(hdr[x+1])
 end
 
;function l(ii:integer):real
;begin
   if ii<0 then l:=65536.0+ii else l:=ii
 end
 
;procedure read1entry
;begin
    ;b:=ord(next)
    ;if b<>26 then begin lineout('Dit is geen arc-file.')
                        ;b:=0
                   end
     else begin
       b:=ord(next)
      ;if b>0 then begin
       for j:=0 to 27 do hdr[j]:=next;
 
      ;templ:=''
      ;j:=0
      ;while (j<13) and (hdr[j]<>char(0)) do
       begin
         templ:=templ+hdr[j]
        ;j:=j+1
       end
      ;for j:=j to 13 do templ:=templ+' '
      ;stringout(templ+char(48+b))
      ;long:=l(int(13))+l(int(15))*65536.0
      ;while long<0 DO long:=long+65536.0
      ;str(long:10:0,templ)
      ;stringout(templ)
      ;long2:=l(int(23))+l(int(25))*65536.0
      ;while long2<0 DO long2:=long2+65536.0
      ;str(long2:10:0,templ)
      ;stringout(templ+' ')
      ;str((long2-long)*100/long2:2:0,templ)
      ;lineout(templ+'%')
      ;tot1:=tot1+long
      ;tot2:=tot2+long2
      ;skip(long)
       end
     end
 end
 
;procedure listarc
;begin
     i:=-1; tot1:=0; tot2:=0; numb:=0
    ;blockread(libfile,libbuff,1)
    ;lineout('Naam         Ver Lengte   Origineel Besparing')
    ;lineout('============ === ======== ========= =========')
    ;repeat
       read1entry
      ;numb:=numb+1
     until b=0
    ;lineout(' ')
    ;str(numb-1:2,templ)
    ;stringout('Aantal files:'+templ)
    ;str(tot1:10:0,templ)
    ;stringout(templ)
    ;str(tot2:10:0,templ)
    ;stringout(templ+' ')
    ;str(((tot2-tot1)*100/tot2):2:0,templ)
    ;lineout(templ+'%')
 end
 
;begin
   listarc
 end;
 
procedure libdir(filename:longname; var result:integer);
  begin
    libassign(filename,result);
    if result=0 then if pos('.LBR',filename)>0 then typedir(result)
                else if pos('.ARC',filename)>0 then arcdir(result)
  end;

  function exists(filename:name): boolean;
    var found:boolean;
    begin
      assign(datafile, filename);
      {$I-} reset(datafile) {$I+};
      found:=(IOresult = 0);
      if found then close(datafile);
      exists:=found;
    end;

  function alpha(filename:name): boolean;
    var strpos:integer;
        okay:boolean;
        dots:byte;
    begin
      dots:=0;
      alpha:=true;
      if length(filename)>0 then
      for strpos:=1 to length(filename) do begin
      if filename[strpos]='.' then dots:=dots+1;
      if not (filename[strpos] in ['.','-','_','0'..'9','A'..'Z'])
      then alpha:=false;
      end;
      if dots>1 then alpha:=false;
    end;

  function getlegal:name;
    var filename:name;
        dotpos:integer;
    begin
      repeat
      filename:=allcaps(getinput('Geef filenaam : ',12,echo));
      dotpos:=pos('.',filename);
      until ((dotpos<10) and (dotpos<>1)
      and (not((dotpos=0) and (length(filename)>8)))
      and (not((dotpos>0) and (length(filename)>dotpos+3)))
      and alpha(filename))
      or (filename='');
      getlegal:=filename;
    end;

  function dirpos(filename:name):integer;
    var loopvar:integer;
    begin
      dirpos:=0;
      loopvar:=0;
      repeat
      loopvar:=loopvar+1;
      until (filetab[loopvar].title=filename) or (loopvar>=enddir);
    if filetab[loopvar].title=filename then dirpos:=loopvar;
    end;

  function getsect:byte;
    var temp:integer;
    begin
      if auto_install then write(cr+lf);
      if sectsin then repeat
      temp:=getint(numsects,0,'Welke sectie (0= allemaal, ?= lijst) : ');
      if temp=-1 then listsections else getsect:=temp;
      until (temp<>-1) or not cts
      else getsect:=1;
    end;

      if temp=-1 then